/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.misslewars;

import java.util.HashSet;
import java.util.Set;

public abstract class StateDependent {
    private static Set<StateDependent> listeners = new HashSet<>();

    private final Set<FightState> active;
    private boolean running;

    public StateDependent(final Set<FightState> active) {
        this.active = active;
        running = false;
        listeners.add(this);
    }

    public abstract void enable();

    public abstract void disable();

    static void setupState(FightState state) {
        if (state == FightState.FIGHTING) {
            FightScoreboard.startTime();
        }
        for (StateDependent listener : listeners) {
            if (listener.running && !listener.active.contains(state)) {
                listener.disable();
                listener.running = false;
            } else if (!listener.running && listener.active.contains(state)) {
                listener.enable();
                listener.running = true;
            }
        }
    }
}
